unit roundedit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, DBTables, ToolWin, ComCtrls, Menus, DBActns,
  ActnList, ImgList, ExtCtrls, DBCtrls, Math, Spin, StdCtrls, FileCtrl;

type
  TRoundWireForm = class(TForm)
    MainMenu1: TMainMenu;
    File1:     TMenuItem;
    Exit1:     TMenuItem;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label1:    TLabel;
    Label2:    TLabel;
    Label3:    TLabel;
    Label4:    TLabel;
    Label5:    TLabel;
    Label6:    TLabel;
    Label7:    TLabel;
    Label8:    TLabel;
    Label9:    TLabel;
    Label10:   TLabel;
    Flabel:    TLabel;
    Llabel:    TLabel;
    Tlabel:    TLabel;
    Slabel:    TLabel;
    RdcLabel:  TLabel;
    RacLabel:  TLabel;
    RraLabel:  TLabel;
    RDCRope:   TLabel;
    RACRope:   TLabel;
    RatioRope: TLabel;
    FUpDown:   TUpDown;
    LUpDown:   TUpDown;
    TUpDown:   TUpDown;
    SUpDown:   TUpDown;
    StringGrid1: TStringGrid;
    DataLabel: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure LUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure TUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure SUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure StringGrid1ColumnMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure StringGrid1RowMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure StringGrid1Click(Sender: TObject);
  private
    { Private declarations }
    procedure Recalc;
    procedure ReadData;
  public
    { Public declarations }
  end;

var
  RoundWireForm: TRoundWireForm;

implementation

{$R *.DFM}

procedure TRoundWireForm.FormCreate(Sender: TObject);
begin
Flabel.Caption := IntToStr(FUpDown.Position);
Llabel.Caption := FloatToStr(LUpDown.Position/2);
Tlabel.Caption := IntToStr(TUpDown.Position);
Slabel.Caption := IntToStr(SUpDown.Position);
StringGrid1.DefaultColWidth := (StringGrid1.Width-28) div StringGrid1.ColCount;
StringGrid1.Cells[0,0] := 'Standard';
StringGrid1.Cells[1,0] := 'Gauge';
StringGrid1.Cells[2,0] := 'Cu Dia / mm';
StringGrid1.Cells[3,0] := 'Dia (L) / mm';
StringGrid1.Cells[4,0] := 'Dia (S) / mm';
StringGrid1.Cells[5,0] := 'Dia (H) / mm';
StringGrid1.Cells[6,0] := 'Dia (T) / mm';
ReadData;
end;

procedure TRoundWireForm.ReadData;
type
  WireData = record
    Standard: String[20];
    Gauge:    String[20];
    CuDia:    String[20];
    Dial:     String[20];
    Dias:     String[20];
    Diah:     String[20];
    Diat:     String[20];
  end;
Var
  WireFile: File of WireData;
  InData:  WireData;
  Fname:   String;
begin
  Fname  := 'wiredata.dat';
  AssignFile(WireFile,Fname);
  If FileExists(Fname) then
  begin
  Reset(WireFile);
  While not Eof(WireFile) do
  begin
  Read(WireFile,InData);
  StringGrid1.Cells[0,(StringGrid1.RowCount-1)] := InData.Standard;
  StringGrid1.Cells[1,(StringGrid1.RowCount-1)] := InData.Gauge;
  StringGrid1.Cells[2,(StringGrid1.RowCount-1)] := InData.CuDia;
  StringGrid1.Cells[3,(StringGrid1.RowCount-1)] := InData.Dial;
  StringGrid1.Cells[4,(StringGrid1.RowCount-1)] := InData.Dias;
  StringGrid1.Cells[5,(StringGrid1.RowCount-1)] := InData.Diah;
  StringGrid1.Cells[6,(StringGrid1.RowCount-1)] := InData.Diat;
  StringGrid1.RowCount := StringGrid1.RowCount+1;
  end;
  CloseFile(WireFile);
  end
  else
  begin
  MessageBox(0,'File "wiredata.dat" Not Found','',MB_ICONEXCLAMATION);
  end;
end;

procedure TRoundWireForm.Recalc;
var
Resistivity  : double;
SkinDepth    : double;
CuDiametre   : double;
InsDiametre  : double;
Height       : double;
LayFact      : double;
Qual         : double;
Mac          : double;
Dac          : double;
Mhalf        : double;
Fratio       : double;
DCR          : double;
ACR          : double;
s            : single;
m            : single;
p            : single;
begin
InsDiametre := 0;
CuDiametre  := 0;
If (StringGrid1.Col > 1) and (StringGrid1.Cells[StringGrid1.Col,StringGrid1.Row] <> '') then
begin
InsDiametre := StrToFloat(StringGrid1.Cells[StringGrid1.Col,StringGrid1.Row])/1000;
CuDiametre  := StrToFloat(StringGrid1.Cells[2,StringGrid1.Row])/1000;
end;
If (InsDiametre>0) and (CuDiametre>0) then
begin
Resistivity := 1.72417E-8*(1+0.00393*(TUpDown.Position-20));
SkinDepth   := Sqrt(Resistivity/(pi*4*pi*1E-7*1000*FUpDown.Position));
Height  := CuDiametre*Sqrt(pi/4);
LayFact := CuDiametre/InsDiametre;
Qual    := Sqrt(LayFact)*Height/SkinDepth;
s       := LUpDown.Position mod 2;
m       := LUpDown.Position - s;
s       := s/2;
m       := m/2;
p       := LUpDown.Position/2;
Mac     := Qual*(sinh(2*Qual)+sin(2*Qual))/(cosh(2*Qual)-cos(2*Qual));
Dac     := 2*Qual*(sinh(Qual)-sin(Qual))/(cosh(Qual)+cos(Qual));
Mhalf   := Qual*(sinh(Qual)+sin(Qual))/(cosh(Qual)-cos(Qual))/2;
Fratio  := (m*(Mac+(p*s+(Sqr(m)-1)/3)*Dac)+s*Mhalf)/p;
DCR     := Resistivity/(Sqr(CuDiametre/2)*pi);
ACR     := Fratio*DCR;
RdcLabel.Caption  := FloatToStrf(DCR,ffGeneral,5,0);
RacLabel.Caption  := FloatToStrf(ACR,ffGeneral,5,0);
RraLabel.Caption  := FloatToStrf(Fratio,ffGeneral,5,0);
RDCRope.Caption   := FloatToStrf(DCR/SUpDown.Position,ffGeneral,5,0);
RACRope.Caption   := FloatToStrf(ACR/SUpDown.Position,ffGeneral,5,0);
RatioRope.Caption := Rralabel.Caption;
end
else
begin
RdcLabel.Caption  := 'Not Available';
RacLabel.Caption  := 'Not Available';
RraLabel.Caption  := 'Not Available';
RDCRope.Caption   := 'Not Available';
RACRope.Caption   := 'Not Available';
RatioRope.Caption := 'Not Available';
end;
end;

procedure TRoundWireForm.Exit1Click(Sender: TObject);
begin
close;
end;

procedure TRoundWireForm.FUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
Flabel.Caption := IntToStr(FUpDown.Position);
Recalc;
end;

procedure TRoundWireForm.LUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
Llabel.Caption := FloatToStr(LUpDown.Position/2);
Recalc;
end;

procedure TRoundWireForm.TUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
Tlabel.Caption := IntToStr(TUpDown.Position);
Recalc;
end;

procedure TRoundWireForm.SUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
Slabel.Caption := IntToStr(SUpDown.Position);
Recalc;
end;


procedure TRoundWireForm.StringGrid1ColumnMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
begin
Recalc;
end;

procedure TRoundWireForm.StringGrid1RowMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
begin
Recalc;
end;

procedure TRoundWireForm.StringGrid1Click(Sender: TObject);
begin
Recalc;
end;

end.
